#!/usr/bin/env python

from distutils.core import setup
from distutils import sysconfig

import os

BASEDIR = os.path.dirname(os.path.abspath(__file__))

def get_data_files(path, files = []):
    l = []
    for name in os.listdir(path):
        if name[0] == ".":
            continue
        relpath = os.path.join(path, name)
        f = os.path.join(BASEDIR, relpath)
        if os.path.isdir(f):
            get_data_files(relpath, files)
        elif os.path.isfile(f):
            l.append(f)
    pref = sysconfig.get_python_lib()[len(sysconfig.PREFIX) + 1:] 
    files.append((os.path.join(pref, path), l)) 
    return files    

setup(
    name="Subway",
    version="0.2",
    description="Python rapid web-development library and framework.",
    author="Peter Hunt",
    author_email='floydophone@gmail.com',
    url='http://subway.python-hosting.com/',
    packages=["subway", "subway.tools", "subway.cherryflow", "subway.framework",],
    scripts=["subway_create.py"],
    data_files = get_data_files(os.path.join("subway","skeleton")),
    )
