import re
import cgi
import urllib
import cherrypy

# todo: what about # named anchors?

RE_HREF = re.compile(r"""(href\s*=\s*'?"?)(.*?)('?"?[\s\>])""", re.IGNORECASE)
RE_ACTION = re.compile(r"""(action\s*=\s*'?"?)(.*?)('?"?[\s\>])""", re.IGNORECASE)

def cherryflow_rewriter(url):
    i = url.find("?")
    j = url.rfind("/")
    if i >= 0:
        basename = url[j+1:i]
    else:
        basename = url[j+1:]
    if basename != cherrypy.request.path[cherrypy.request.path.rfind("/")+1:]:
        return url
    if i > 0:
        qs = cgi.parse_qs(url[i+1:])
        qs["_resume"] = cherrypy.request.resume_id
        return url[:i] + "?" + cgi.escape(urllib.urlencode(qs, True))
    else:
        return url + "?_resume=" + `cherrypy.request.resume_id`

def rewrite(doc, func):
    def subfunc(match):
        return match.group(1) + func(match.group(2)) + match.group(3)
    return RE_ACTION.sub(subfunc, RE_HREF.sub(subfunc, doc))

def rewritten(func, mimeTypeList=["text/html"]):
    """
    rewriter decorator
    """
    def _d(method):
        def _m(*args, **kwargs):
            if cherrypy.response.headerMap.get("Content-type", "text/html") in mimeTypeList:
                return rewrite(method(*args, **kwargs), func)
            else:
                return method(*args, **kwargs)
        return _m
    return _d

flow_rewrite = rewritten(cherryflow_rewriter)

