import cherrypy

class Model(object):
    _subway_model = True
    
try:
    import sqlobject
    from sqlobject import dbconnection
    sql_connection = dbconnection.ConnectionHub()
    class SQLModel(Model, sqlobject.SQLObject):
        _connection = sql_connection
        fields = property(lambda self: dict(self.field_list))
        field_list = property(lambda self: [(col.name, getattr(self, col.name)) for col in self._columns])
    def sql_connect(index):
        """
        give sqlobject access in this thread
        """
        try:
            sql_connection.threadConnection
        except AttributeError:
            uri = cherrypy.config.get("subway.sql_connection", None)
            if uri:
                sql_connection.threadConnection = sqlobject.connectionForURI(uri)
    cherrypy.server.onStartThreadList.append(sql_connect)
except ImportError:
    cherrypy.log("SQLModel unavailable; install SQLObject.")
    SQLModel = Model
    sql_connection = None
    sql_connect = lambda _: None
