import formencode
from formencode import htmlfill_schemabuilder
import types
import api
import cherrypy
from cherrypy.lib.filter import basefilter

class FormErrors(api.Wrapper):
    d = property(lambda self: cherrypy.threadData.form_errors)
    def __init__(self):
        api.Wrapper.__init__(self)        

form_errors = FormErrors()

class FormDefaults(api.Wrapper):
    d = property(lambda self: cherrypy.threadData.form_defaults)
    def __init__(self):
        api.Wrapper.__init__(self)

form_defaults = FormDefaults()

noncopy_attrs = dir(types.FunctionType)
noncopy_attrs.remove("__doc__")

def handler(schema, state=None):
    """
    Form handler for a given schema.
    schema must be a formencode schema
    """
    def decorator(method):
        def _m(*args, **kwargs):
            form_errors.clear()
            form_defaults.clear()
            try:
                #kwargs = formencode.to_python(schema, kwargs, state)
                kwargs = schema.to_python(kwargs, state)
            except formencode.Invalid, e:
                form_errors.update(e.unpack_errors())
            return method(*args, **kwargs)
        # copy over the function's attributes
        for name in dir(method):
            if name not in noncopy_attrs:
                setattr(_m, name, getattr(method, name))
        return _m
    return decorator

def add_validator(name, cls):
    htmlfill_schemabuilder.default_validators[name.lower()] = cls
    