import subway
import cherrypy
from subway import cherryflow

def get_superglobal_namespace():
    """
    Namespace of all of Subway's "superglobals"
    """
    return {"request" : subway.request,
            "response" : subway.response,
            "session" : subway.session,
            "config" : cherrypy.config,
            "subway" : subway}

def get_controller_namespace(view_manager, model):
    ns = get_superglobal_namespace()
    
    #@@ TODO: export "flow" also
    ns.update({
               "view" : view_manager,
               "model" : model,
               "expose" : subway.expose,
               "docstring_view" : subway.docstring_view,
               "form_handler" : subway.form_handler,
               "auth" : subway.auth,
               "form_errors" : subway.form_errors,
               "form_defaults" : subway.form_defaults,
               "flow" : subway.flow,
               "MILESTONE" : subway.MILESTONE,
               #"flash": subway.FlashFilter.session_flash, 
               })
    return ns

def get_model_namespace():
    ns = get_superglobal_namespace()
    
    #@@ TODO: export "model" also, maybe rename Model in BaseModel
    ns.update({"Model" : subway.Model,
               "SQLModel" : subway.SQLModel,
               })
    try:
        import sqlobject
        ns.update(sqlobject.__dict__)
    except ImportError:
        pass
    return ns

def get_daemon_namespace(model):
    ns = get_superglobal_namespace()
    ns["model"] = model
    return ns

DEFAULT_VIEW_NAMESPACE = {
    "escape" : subway.escape,
    "local_request" : subway.local_request,
    "resume_id" : lambda: cherrypy.request.resume_id
}

def get_view_namespace():
    ns = get_superglobal_namespace()
    ns.update(DEFAULT_VIEW_NAMESPACE)
    return ns
