def start_server(homedir=None):
    """
    start_server(): execute a Subway app
    assumes homedir is one level up from cwd unless
    argument is provided.
    """
    from subway import framework
    import os
    import cherrypy
    import optparse
    if not homedir:
        import __main__
        homedir = os.path.split(os.path.dirname(os.path.abspath(getattr(__main__,"__file__",os.getcwd()))))[0]
    parser = optparse.OptionParser()
    parser.add_option("-w",
                      "--webserver",
                      action="store_true",
                      dest="webserver",
                      default=True,
                      help="Start the Subway web server. Defaults to on.")
    parser.add_option("-d",
                      "--daemons",
                      dest="daemons",
                      default="*",
                      help="Specify which daemons to start in a comma-delimited list. Defaults to all daemons. To specify all daemons, do -d *. To specify no daemons, do -d none")
    options, args = parser.parse_args()
    framework.init_app(homedir)
    if options.daemons == "*":
        options.daemons = None
    elif options.daemons == "none":
        options.daemons = []
    else:
        options.daemons = options.daemons.split(",")
    framework.load_daemons(homedir, options.daemons, not options.webserver)
    if options.webserver:
        framework.load_webapp_server(homedir)
    
